/**
slideshow con effetto fade e testo 1.0

Copyright (c) 2012 Marco Zanette http://www.marcozanette.com

Author / Autore: Marco Zanette http://www.marcozanette.com

Licensed under the MIT license / Rilasciato con licenza MIT.


Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

**/
Array.prototype.indexOf = function(needle) {
	for(var i = 0; i < this.length; i++){
		 if(this[i] === needle){
			return i;
		}
	 }
	 return -1;
}


function SlideshowFade(wrapper, time, popup){
	
	var position = 0;
	var imgs = document.getElementById(wrapper).getElementsByTagName('img');
	
	var useTxt = popup;
	var durationTime = time;
	
	var arrayImgs = new Array();	
	for(var i=0; i<imgs.length; i++){
		arrayImgs[i] = imgs[i];
		arrayImgs[i].style.opacity = 0;
		arrayImgs[i].style.filter = 'alpha(opacity=0)';
	}	
	
	if(useTxt == 1){
		var popupDiv = document.createElement('div');
		popupDiv.id = "popup_txt";
		document.getElementById(wrapper).appendChild(popupDiv);
		var topPosition = popupDiv.offsetTop;
		var totalHeight = document.getElementById(wrapper).offsetHeight;
		if(arrayImgs[position].title != ""){
			var titleImg = '<h4 class="titleImage">'+arrayImgs[position].title+'</h4>';
		} else {
			var titleImg = '';
		}
		if(arrayImgs[position].alt != ""){
			var txtImg = arrayImgs[position].alt;
		} else {
			var txtImg = '';
		}
		
		if((txtImg != "") || (titleImg != "")){
			popupDiv.innerHTML =titleImg+txtImg;
		} else {
			popupDiv.style.top = totalHeight+"px";
		}
		
	}

	arrayImgs[position].style.zIndex = "10";
	arrayImgs[position].style.opacity = 1;
	arrayImgs[position].style.filter = 'alpha(opacity=100)';
	
	

	
	// :::::::::::::::::  function fade out   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	function playOpacity(obj){		
		if(Math.floor(obj.style.opacity*100) == 50){
			if(useTxt == 1){
				moveOutPopup();
			}
			callNextImg(obj);	
		}
		
		if(Math.floor(obj.style.opacity*100) > 0){	
			var newValOpacity = (Math.floor(obj.style.opacity*100)-1);			
			obj.style.opacity = newValOpacity/100;
			obj.style.filter = 'alpha(opacity=' + newValOpacity + ')';
			setTimeout(function(){ playOpacity(obj); },30);
		} 
	}
	
	setTimeout(function(){ playOpacity(arrayImgs[position]); },durationTime);
	
	
	
	// :::::::::::::::::  function call next img animation   :::::::::::::::::::::::::::::::::::::::::
	function callNextImg(obj){		
		obj.style.zIndex = "0";
		var nuovoOggIndice = arrayImgs.indexOf(obj)+1;
		if(nuovoOggIndice > arrayImgs.length-1){
			nuovoOggIndice = 0;
		}
		arrayImgs[nuovoOggIndice].style.zIndex = "10";
		settingUpNextImg(arrayImgs[nuovoOggIndice]);
	}
	
	
	// :::::::::::::::::  function fade in new img   :::::::::::::::::::::::::::::::::::::::::::::::::
	function settingUpNextImg(obj){		
		if(Math.floor(obj.style.opacity*100) == 40){
			if(useTxt == 1){
				
				var indexImg = arrayImgs.indexOf(obj);
				
				if(arrayImgs[indexImg].title != ""){
					titleImg = '<h4 class="titleImage">'+arrayImgs[indexImg].title+'</h4>';
				} else {
					titleImg = '';
				}
				if(arrayImgs[indexImg].alt != ""){
					txtImg = arrayImgs[indexImg].alt;
				} else {
					txtImg = '';
				}				
				
				var text = titleImg+txtImg;
				if(text != ""){
					popupDiv.innerHTML = text;
					moveInPopup();
				}
			}
		}
		
		if(Math.floor(obj.style.opacity*100) < 100){
			var newValOpacity = (Math.floor(obj.style.opacity*100)+1);		
			obj.style.opacity = ((obj.style.opacity*100)+1)/100;
			obj.style.filter = 'alpha(opacity=' + newValOpacity + ')';
			setTimeout(function(){ settingUpNextImg(obj); },30);
		} else {
			var indexObjPrec = arrayImgs.indexOf(obj)-1;
			if(indexObjPrec == -1){
				indexObjPrec = arrayImgs.length-1;
			}
			arrayImgs[indexObjPrec].style.zIndex = "-10";
			setTimeout(function(){ playOpacity(obj); },durationTime);
		}
	}
	
	
	
	// :::::::::::::::::  function move out popup   :::::::::::::::::::::::::::::::::::::::::::::::::
	function moveOutPopup(){
		if(popupDiv.offsetTop < totalHeight){
			popupDiv.style.top = popupDiv.offsetTop+3+"px";
			setTimeout(moveOutPopup,1);
		} else {
			popupDiv.style.top = totalHeight+"px";
		}
	}
	
	
	// :::::::::::::::::  function move in popup   :::::::::::::::::::::::::::::::::::::::::::::::::
	function moveInPopup(){
		if(popupDiv.offsetTop > topPosition){
			popupDiv.style.top = popupDiv.offsetTop-3+"px";
			setTimeout(moveInPopup,1);
		} else {
			popupDiv.style.top = topPosition+"px";
		}
	}
	
}

