/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */


var sys = {};
// Position Var
var currentPosition = null;
var latitudeP;
var longitudeP;
var webRoot = "./";
$.ui.autoLaunch = false; //By default, it is set to true and you're app will run right away.  We set it to false to show a splashscreen
/* This function runs when the body is loaded.*/

var init = function () {

    $.ui.backButtonText = "Back";// We override the back button text to always say "Back"
    window.setTimeout(function () {
                      $.ui.launch();
                      }, 1500);//We wait 1.5 seconds to call $.ui.launch after DOMContentLoaded fires
    $.ui.toggleHeaderMenu(false);
};

document.addEventListener("DOMContentLoaded", init, false);

$.ui.ready(function () {

           $.ui.useAjaxCacheBuster=true;

           $('#afui').removeClass('android').removeClass('ios').removeClass('ios7');
           
           os = printOS();
           
           //staticPages();
           
           if ($.os.android ) {
           // Hide/Show the nav menu when the keyboard is opened/closed
           document.addEventListener("hidekeyboard", keyboardHide, false);
           document.addEventListener("showkeyboard", keyboardShow, false);
           
           // Dont show the backbutton on Android devices
           $('#backButton').css('display','none !important');
           $('.subpanelContainer').css('overflow','hidden !important');
           
           if ( $.os.android ) {
           // No font gradient on ANY android :(
           $('#navbar .icon').addClass('nomask');
           }
           }
           
           if( cloneMenu ) {
           // Populate the sidemenu with the content of the navbar!
           $('nav').append($("#navbar a").clone());
           $('nav a').each( function() {
                           $(this).addClass('sidemenu');
                           });
           
           // add logo
           $('nav').append('<img src="./app/content/images/logo.png">');
           
           // $( $('nav a.sidemenu')[0] ).addClass('select');
           $.ui.updateSideMenu($('nav').children() );
           
           
           // Add "select" class to side menu when clicked
           $("#menu a.sidemenu").bind("click", function() {
                                      $('#menu a.sidemenu').removeClass('select');
                                      $(this).addClass('select');
                                      });
           
           }
           
           
           // Add "select" class to subpanel buttons when clicked
           $(".subpanelNav").each( function() {
                                  var subPanNum = "two";
                                  $(this).each( function() {
                                               if ( this.childElementCount == 2 ) subPanNum="twoSub";
                                               if ( this.childElementCount == 3 ) subPanNum="threeSub";
                                               if ( this.childElementCount == 4 ) subPanNum="fourSub";
                                               $(this).children().each( function() {
                                                                       $(this).addClass(subPanNum);
                                                                       });
                                               });
                                  });
           $(".subpanelNav a").bind("click", function() {
                                    var varpar = $(this).parent('div').parent('div').attr("id");
                                    $("#" + varpar + " .subpanelNav a").removeClass('select');
                                    $(this).addClass('select');
                                    });

           initAll();
           
           var themeCSS = document.createElement("link");
           themeCSS.rel = "stylesheet";
           themeCSS.type= "text/css";
           themeCSS.href= "./app/content/theme.css";
           $("head").append(themeCSS);
           
           // debug
           console.log('ready');
           });



/* This code is used for Intel native apps */
var onDeviceReady = function () {

    initPushwoosh();

    StatusBar.overlaysWebView(false);
    StatusBar.backgroundColorByHexString("#ffffff");
    StatusBar.styleDefault();


    $('body').prepend('<div id="loadingApp">&nbsp;</div>');
    
    if($.os.ios) {
        
        navigator.geolocation.getCurrentPosition(GeoSuccess, GeoError);
    } else if ($.os.android) {
        var options = { enableHighAccuracy: true };
        navigator.geolocation.getCurrentPosition(GeoSuccess, GeoError, options );
    } else {

        // I'm on browser!
        latitudeP = 43.289562;
        longitudeP = 11.268121;
        
        currentPosition = true;
        
        addressFromGoogle();
    }
    
    if( !localStorage.getItem("lang") ){
        if( lang.length > 1 ) {
            var popupLanguage = '<div id="popupLanguage">';
            popupLanguage    += '<img src="./app/content/images/logo.png" class="popupLogo">';
            for( languages in lang ) {
                popupLanguage    += '<img src="./app/core/plugins/language/images/flag-'+lang[languages]+'.png" class="flag" onclick="chooseLang(\''+lang[languages]+'\');">';
            }
            popupLanguage    += '</div>';
            
            $("body").prepend(popupLanguage);
            
        } else {
            // Se c'è una sola lingua, parte con quella.
            localizer("language", lang[0] );
        }
    } else {
        localizer("language", localStorage.getItem("lang") );
    }



};

// This is to test on browser!
if( !$.os.android && !$.os.ios ) {
    document.addEventListener("DOMContentLoaded",onDeviceReady,false);
}

function triggerFocus() {
    if($.os.android) {
        window.setTimeout( function() {
                          window.plugins.SoftKeyBoard.show();
                          }, 50);
    }
}
function triggerBlur() {
    if($.os.android) {
        window.plugins.SoftKeyBoard.hide();
    }
}

// include touch.js on desktop browsers only
if(!((window.DocumentTouch&&document instanceof DocumentTouch)||'ontouchstart' in window)){
    var script=document.createElement("script");
    
    script.src="ui/plugins/af.desktopBrowsers.js";
    var tag = $("head").append(script);
}

/* FUNZIONI di SISTEMA */
// check if smartphone
function checkSmartphone(){
    if( window.innerWidth < 768 ) {
        return true;
    } else {
        return false;
    }
    
}
var smartphone = checkSmartphone();

// to know the version of android
var androidversion;
if ($.os.android ) {
    androidversion = parseFloat( navigator.userAgent.match(/Android (\d+(?:\.\d+)+)/)[0].replace('Android ','') );
}


// common string trimmer
function stringTrimmer(string, si, ti){
    var leng;
    
    if(smartphone){
        leng = si;
    } else {
        leng = ti;
    }
    
    if(string.length > leng) {
        string = string.substring(0,leng)+"...";
    }
    return string;
}


window.alert = function(text) {
    if(text===null||text===undefined)
        text = "null";
    if( $("#afui").length>0 ) {
        $("#afui").popup( { message: text.toString(), suppressTitle: true, cancelOnly: true, cancelText: 'Ok' });
    } else {
        $(document.body).popup(text.toString());
    }
}

function error(id,msg){
    $("#" + id).html(msg);
    $("#" + id).fadeIn("300ms", function(){
                       window.setTimeout( function() {
                                         $("#" + id).fadeOut("1000ms", null, 0);
                                         }, 1000);
                       } );
}

// TODO: wiki variable OS (it's set in jqready);
var os;
function printOS(){
    var aos;
    if($.os.webkit){    aos = "Webkit Browser";} //True if webkit found in the user agent
    if($.os.android){   aos = "Android";}        //True if anroid useragent
    if($.os.ipad){      aos = "iPad";}           //True if iPad useragent
    if($.os.iphone){    aos = "iPhone";}         //Tru if iPhone user agent
    return aos;
}

// TODO: wiki this!
function keyboardHide() {
    $.ui.toggleNavMenu(true);
}
function keyboardShow() {
    $.ui.toggleNavMenu(false);
}

function GeoSuccess(position) {
    if( position.coords.latitude == 'undefined' || position.coords.longitude == 'undefined') {
        GeoError();
    } else {
        
        latitudeP = position.coords.latitude;
        longitudeP = position.coords.longitude;
        console.log(latitudeP+" "+longitudeP);
        currentPosition = true;
        console.log('Position Saved');
        
        addressFromGoogle();
        $(document).trigger('geoDone');
    }
}

function GeoError(error) {
    currentPosition = false;
    console.log('No Position');
    $(document).trigger('geoDone');
}

function addressFromGoogle() {
    $.ajax({
           url      : "http://maps.googleapis.com/maps/api/geocode/json?latlng="+latitudeP+","+longitudeP+"&sensor=false",
           dataType : 'json',
           crossDomain: true,
           success  : function(data) {
           if( data.status == "OK") {
           var comune = data.results[3].address_components[0].long_name;
           $("#selectedCity").text(comune);
           localStorage.setItem("city",comune);
           $(document).trigger('geoDone');
           } else {
           GeoError();
           }
           },
           error: function(){
           navigator.notification.alert(
                                        'Per visualizzare questa pagina hai bisogno di una connessione',  // message
                                        alertDismissed,         // callback
                                        'Errore',            // title
                                        'Ok'                  // buttonName
                                        );
           
           GeoError();
           }
           });
}


document.addEventListener("deviceready", onDeviceReady, false);

